// ŎgpC^[tFCX

#pragma once

#include <Windows.h>
#include "Smf.h"


namespace GuruGuruSmf { namespace Core
{
	/// <summary>
	/// SMFRg[[̃C^[tFCX
	/// </summary>
	struct ISmfController
	{
		// SMFIuWFNg擾
		virtual Smf* GetSmf() = 0;

		// J
		virtual GGSERROR Open() = 0;

		// 
		virtual void Close() = 0;
	};

	/// <summary>
	/// vC[̃C^[tFCX
	/// </summary>
	struct IPlayer
	{
		// fXgN^(Ȃ㩂Ƀn}܂)
		virtual ~IPlayer(){}

		// foCXJ
		virtual GGSERROR OpenDevice(int deviceId, HWND handle) = 0;
		
		// foCX
		virtual void CloseDevice() = 0;
		
		// tI
		virtual GGSERROR Play(ISmfController* smfCtrl, int option, int seek, int fadeInTime, int keyShift) = 0;
		
		// ~I
		virtual void Stop(int fadeOutTime) = 0;
		
		// ꎞ~
		virtual void Pause() = 0;
		
		// ꎞ~
		virtual void Restart() = 0;
		
		// tԂ擾
		virtual void GetStatus(PlayerStatus* status) = 0;
		
		// }X^[e|
		virtual void SetMasterTempo(float tempo) = 0;
		
		// }X^[{[
		virtual void SetMasterVolume(int volume) = 0;
		
		// }X^[sb`
		virtual void SetMasterPitch(int pitch) = 0;
	};
	
	/// <summary>
	/// foCX̃C^[tFCX
	/// </summary>
	struct IDevice
	{
		// MIDIbZ[W𑗐M
		virtual GGSERROR SendLongMessage(const byte* data, int length) = 0;
		
		// ZMIDIbZ[W𑗐M
		virtual GGSERROR SendShortMessage(int status, int data1, int data2) = 0;
	};
	
	/// <summary>
	/// PlayerANZXp̃C^[tFCX
	/// </summary>
	struct IPlayerCore
	{
		// MIDIbZ[WMfoCX擾
		virtual IDevice* GetDevice() = 0;
		
		// }[J[TickɉZ
		virtual void AddMarkerTick(int deltaTime) = 0;
		
		// I_
		virtual void MusicEnd() = 0;
		
		// e|Zbg
		virtual void SetTempo(int newTempo) = 0;
		
		// {[bZ[W𑗐M
		virtual void SendVolume(int channel, int volume) = 0;
		
		// sb`xhbZ[W𑗐M
		virtual void SendPitchBend(int channel, int pitch) = 0;
		
		// GNXN[Vu𑗐M
		virtual void SendExclusive(CodeEvent* codeEvent) = 0;
		
		// SeekpɃCxgo^
		virtual void RegisterEvent(CODE_EVENTTYPE type, int channel, int data1, CodeEvent* codeEvent) = 0;

		// Vtgꂽm[gԍ擾
		virtual int GetShiftedNote(int note, int channel) = 0;
	};
	
	/// <summary>
	/// Analyzer̓ANZXp̃C^[tFCX
	/// </summary>
	struct IAnalyzerCore
	{
		virtual void SetTempo(int newTempo) = 0;
		virtual void NoteEvent(bool isNoteOn) = 0;
		virtual void ProgramChangeEvent(int channel, int voice) = 0;
		virtual void BankSelectEvent(int channel, bool isMsb, int bank) = 0;
		virtual void UseRhythmPartEvent(int channel, bool isRhythmPart) = 0;
		virtual void VolumeEvent(int volume) = 0;
		virtual void MarkLoopPoint() = 0;
	};
	
	/// <summary>
	/// Compiler̓ANZXp̃C^[tFCX
	/// </summary>
	struct ICompilerCore
	{
		// CodeIuWFNg
		virtual GgsCode* GetCode() = 0;
		
		// 2oCg̃f[^Cxg
		virtual void Write2ByteEvent(CODE_EVENTTYPE type, SmfEvent* smfEvent) = 0;
		
		// GNXN[VuCxg
		virtual void WriteExclusiveEvent(SmfEvent* smfEvent) = 0;
		
		// Yp[gCxg
		virtual void WriteUseRhythmPartEvent(SmfEvent* smfEvent, int channel, bool rhythm) = 0;
	};
	
	
	
	/// <summary>
	/// DirectMusic̃^C}[@\
	/// </summary>
	struct IDirectMusicTimer
	{
		virtual __int64 GetMarkerDmTime() = 0;
		virtual void IncrementMarkerDmTime() = 0;
	};
	
}}

