// SMF

#pragma once

#include "Constants.h"
#include "Smf.h"

namespace GuruGuruSmf { namespace Core {
	
	/// <summary>
	/// SMFNX
	/// </summary>
	class SmfInterpreter
	{
	public:
		/// <summary>
		/// 1gbÑf[^
		/// </summary>
		struct TrackData
		{
			SmfTrack* SmfTrack;		// gbNIuWFNg̎Q
			TRACKSTATE State;				// gbN̏
			int Tick;				// Tick
		};
		
	private:
		Smf* smf;
		int trackCount;
		TrackData* trackData;
		
		// SgbNōŏTick擾BIĂ-1Ԃ
		int GetMinTick();
		
	protected:
		SmfInterpreter();	// RXgN^
		virtual ~SmfInterpreter();	// fXgN^
		
		// SMFIuWFNgu
		Smf* GetSmf(){ return smf; }
		
		// gbN
		int GetTrackCount(){ return trackCount; }
		
		// wSMFŏ
		virtual void Initialize(Smf* newSmf);
		
		// ŏ܂Ŋ߂
		virtual void Rewind();
		
		// Ticki߂
		virtual void UpdateTick(int newTick) = 0;
		
		// Cxg
		virtual void EventExecute(SmfEvent* smfEvent) = 0;
		
		// Cxg߂ď
		GGSERROR InterpretSmf();
		
		
	};
	
	
}}




