// ʊ֌W

#pragma once

#include <Windows.h>
#include "Constants.h"
#include "Interface.h"

namespace GuruGuruSmf { namespace Core {

	/// <summary>
	/// ʃRg[
	/// </summary>
	class Volume
	{
	private:
		IDevice* device;
		VOLUMESTATE state;
		int* volumes;
		int masterVolume, normalizedGain;
		bool updated;
		int fadingCount, fadingTime, fadingGain, oldFadingGain;
		CRITICAL_SECTION lockObject;

	public:
		Volume(IDevice* dev);	// RXgN^
		~Volume();	// fXgN^

		// 
		int GetState(){ return state; }
		
		// trueƉʂI0ɂAfalseƉ()
		void Mute(bool isMute);
		
		// `lƂ̃{[ݒ()
		void SetVolume(int channel, int vol);
		
		// }X^[{[ݒ(񓯊)
		void SetMasterVolume(int vol);
		
		// tF[hCݒ(񓯊) InitializeModulȇOɌĂ
		void SetFadeIn(int time);
		
		// tF[hAEgݒ(񓯊)
		void SetFadeOut(int time);

		// tF[hʂvZ
		void CalcFadingGain();
		
		// 񓯊p̃Gg[|Cg turȅꍇtF[hAEgI
		bool Worker();
		
		// 
		void InitializeModule(bool normalize, int maxVolume);

	};


}}


